/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERVICOROP                                               */
/* Tabela : SERVICOROP                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 29/05/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SERVICOROP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SERVICOROP
GO


CREATE TRIGGER DTULTATU_SERVICOROP
ON SERVICOROP
FOR INSERT, UPDATE, DELETE
AS

BEGIN

   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERVICOROP', null, 'CDFILIAL=' + CDFILIAL + ';CDSERVFILI=' + CDSERVFILI +
                       ';IDTPSERVICOROP=' + IDTPSERVICOROP + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERVICOROP
      SET DTULTATUSROP = GETDATE()
      FROM INSERTED;
   END;
   
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SERVICOROP','4.11.136';
GO

