const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const modalidadePage = require('../../page-objects/pedidos/modalidadeDePagamento.po.js');
const j = require('../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const desconto = Helper.util.geraInt(1, 80);
const modalidadeGridId = '18300989417565927561616';
const formaPagamento2 = '7 DIAS';
const formaPagamento2Modificado = '14 DIAS';
const parcelas = Helper.util.geraInt(10, 30);
const diaPagamento = Helper.util.geraInt(10, 30);
const descontoModificado = (desconto - 5);
const descontoFormatado = Helper.util.formataReal(desconto);

describe('Tela Modalidade de Pagamento', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		modalidadePage.abrir();
	});

	afterEach(() => {
		geral.sair();
	});

	it('Deve acessar a tela Modalidade de Pagamento', () => {
		expect(z.component.header.getTitle()).toBe('Modalidade de Pagamento');
	});

	it('Deve adicionar uma modalidade de pagamento', () => {
		geral.clickAdicionar();
		modalidadePage.adicionarModalidade(j.getValor('codigo2'), j.getValor('modalidadePagamento'),
			desconto, j.getValor('tipoPagamento'), j.getValor('formaPagamento'), diaPagamento,
			parcelas, 'Sim', formaPagamento2);
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${modalidadeGridId}`)));
		browser.sleep(2000);

		expect(geral.gridHasText(modalidadeGridId, j.getValor('modalidadePagamento'), 1))
			.toBe(j.getValor('modalidadePagamento'));
		expect(geral.gridHasText(modalidadeGridId, descontoFormatado, 2))
			.toBe(descontoFormatado);
	});

	it('Deve Editar modalidade de pagamento', () => {
		geral.filterIt(j.getValor('modalidadePagamento'));
		geral.clickGrid('DSMODPGTO', j.getValor('modalidadePagamento'), modalidadeGridId);
		geral.clickEditar();

		modalidadePage.editarModalidade(j.getValor('modalidadePagamento1'),
			descontoModificado, j.getValor('tipoPagamento'), j.getValor('formaPagamento1'), diaPagamento,
			(parcelas - 5), 'Não', formaPagamento2Modificado);
		geral.clickSalvar();
		geral.waitFieldVisibility('VRPEDESMODPG');

		expect(geral.getTextoPorId('VRPEDESMODPG'))
			.toMatch(descontoModificado.toString());
		expect(geral.getTextoPorId('IDTPFORPGTOMOD'))
			.toBe(j.getValor('formaPagamento1'));
	});

	it('Deve excluir modalidade de pagamento', () => {
		geral.filterIt(j.getValor('modalidadePagamento1'));
		geral.clickGrid('DSMODPGTO', j.getValor('modalidadePagamento1'), modalidadeGridId);
		geral.clickExcluir();
		geral.clickSim();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${modalidadeGridId}`)));

		expect(geral.gridHasText(modalidadeGridId, j.getValor('codigo2')))
			.toBeUndefined();
		expect(geral.gridHasText(modalidadeGridId, j.getValor('formaPagamento1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(modalidadeGridId, descontoModificado, 2))
			.toBeUndefined();
	});
});

